blob: 924f32d1018ccf551f36d558fb41b60f2b668484 [file] [log] [blame]
Holger Hans Peter Freyther11a60552014-04-03 12:15:02 +02001#!/bin/sh
2### BEGIN INIT INFO
3# Provides: osmo-gbproxy
4# Required-Start: $network $local_fs
5# Required-Stop:
6# Default-Start: 2 3 4 5
7# Default-Stop: 0 1 6
8# Short-Description: Osmocom GBproxy
9# Description: A tool to proxy the GPRS Gb interface.
10### END INIT INFO
11
12# Author: Harald Welte <laforge@gnumonks.org>
13
14# PATH should only include /usr/* if it runs after the mountnfs.sh script
15PATH=/sbin:/usr/sbin:/bin:/usr/bin
Holger Hans Peter Freyther67948a62014-07-17 07:31:42 +020016NAME=osmo-gbproxy # Introduce the short server's name here
Holger Hans Peter Freyther81d8c892014-04-24 10:06:55 +020017DESC="Osmocom GBProxy" # Introduce a short description here
Holger Hans Peter Freyther11a60552014-04-03 12:15:02 +020018DAEMON=/usr/bin/osmo-gbproxy # Introduce the server's location here
19SCRIPTNAME=/etc/init.d/osmocom-gbproxy
Holger Hans Peter Freyther81d8c892014-04-24 10:06:55 +020020CONFIG_FILE=/etc/osmocom/osmocom-gbproxy.cfg
Holger Hans Peter Freyther11a60552014-04-03 12:15:02 +020021
22# Exit if the package is not installed
23[ -x $DAEMON ] || exit 0
24
25# Read configuration variable file if it is present
26[ -r /etc/default/osmocom-gbproxy ] && . /etc/default/osmocom-gbproxy
27
28# Load the VERBOSE setting and other rcS variables
29. /lib/init/vars.sh
30
31# Define LSB log_* functions.
32# Depend on lsb-base (>= 3.0-6) to ensure that this file is present.
33. /lib/lsb/init-functions
34
35DAEMON_ARGS="-D -c $CONFIG_FILE"
36
37#
38# Function that starts the daemon/service
39#
40do_start()
41{
42 # Return
43 # 0 if daemon has been started
44 # 1 if daemon was already running
45 # 2 if daemon could not be started
46 start-stop-daemon --start --quiet --exec $DAEMON --test > /dev/null \
47 || return 1
48 start-stop-daemon --start --quiet --exec $DAEMON -- \
49 $DAEMON_ARGS \
50 || return 2
51 # Add code here, if necessary, that waits for the process to be ready
52 # to handle requests from services started subsequently which depend
53 # on this one. As a last resort, sleep for some time.
54}
55
56#
57# Function that stops the daemon/service
58#
59do_stop()
60{
61 # Return
62 # 0 if daemon has been stopped
63 # 1 if daemon was already stopped
64 # 2 if daemon could not be stopped
65 # other if a failure occurred
66 start-stop-daemon --stop --quiet --retry=TERM/30/KILL/5 --name $NAME
67 RETVAL="$?"
68 [ "$RETVAL" = 2 ] && return 2
69 # Wait for children to finish too if this is a daemon that forks
70 # and if the daemon is only ever run from this initscript.
71 # If the above conditions are not satisfied then add some other code
72 # that waits for the process to drop all resources that could be
73 # needed by services started subsequently. A last resort is to
74 # sleep for some time.
75 start-stop-daemon --stop --quiet --oknodo --retry=0/30/KILL/5 --exec $DAEMON
76 [ "$?" = 2 ] && return 2
77 return "$RETVAL"
78}
79
80#
81# Function that sends a SIGHUP to the daemon/service
82#
83do_reload() {
84 #
85 # If the daemon can reload its configuration without
86 # restarting (for example, when it is sent a SIGHUP),
87 # then implement that here.
88 #
89 start-stop-daemon --stop --signal 1 --quiet $PIDFILE --name $NAME
90 return 0
91}
92
93case "$1" in
94 start)
95 [ "$VERBOSE" != no ] && log_daemon_msg "Starting $DESC " "$NAME"
96 do_start
97 case "$?" in
98 0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
99 2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
100 esac
101 ;;
102 stop)
103 [ "$VERBOSE" != no ] && log_daemon_msg "Stopping $DESC" "$NAME"
104 do_stop
105 case "$?" in
106 0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
107 2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
108 esac
109 ;;
110 status)
111 status_of_proc "$DAEMON" "$NAME" && exit 0 || exit $?
112 ;;
113 #reload|force-reload)
114 #
115 # If do_reload() is not implemented then leave this commented out
116 # and leave 'force-reload' as an alias for 'restart'.
117 #
118 #log_daemon_msg "Reloading $DESC" "$NAME"
119 #do_reload
120 #log_end_msg $?
121 #;;
122 restart|force-reload)
123 #
124 # If the "reload" option is implemented then remove the
125 # 'force-reload' alias
126 #
127 log_daemon_msg "Restarting $DESC" "$NAME"
128 do_stop
129 case "$?" in
130 0|1)
131 do_start
132 case "$?" in
133 0) log_end_msg 0 ;;
134 1) log_end_msg 1 ;; # Old process is still running
135 *) log_end_msg 1 ;; # Failed to start
136 esac
137 ;;
138 *)
139 # Failed to stop
140 log_end_msg 1
141 ;;
142 esac
143 ;;
144 *)
145 #echo "Usage: $SCRIPTNAME {start|stop|restart|reload|force-reload}" >&2
146 echo "Usage: $SCRIPTNAME {start|stop|status|restart|force-reload}" >&2
147 exit 3
148 ;;
149esac
150
151: